/*
 * Test.java
 */

package no.ingeberg.NewsML;
import java.lang.String;
import java.io.*;
import java.net.*;
import java.util.*;
/**
 *
 * @author  Administrator
 */
public class Test {
    private static String LF = System.getProperty("line.seperator", new String("\n"));
    private static String SLASH = System.getProperty("file.seperator", new String("\\"));
    private static String TAB = System.getProperty("tab.seperator", new String("\t")); 
    
    private NewsML myNewsML= null;
    
    /** Creates a new instance of Test */
    public Test() {
        newsItemTest();
    }
    
    public static void main(String args[]) {
        new Test();
    }
    
    private void filTest(){
       //public void skrivObjektTilFil(File file, NewsML newsML)
       //public NewsML lesObjektFraFil(File file)
        File file = new File("c:\\test.bin");
        //skrivObjektTilFil(file, new NewsML());
        myNewsML = lesObjektFraFil(file);
    }
    
    
    public Catalog nyCatalog(String catalogHref, String URN, String URL, String defVocContext, String defVocScheme,String topicUse, 
                            String topicUseContext){
        Resource resource = null;
        try {
            URL resourceURN     = new URL(URN);
            URL resourceURL     = new URL(URL);
            resource   = new Resource(resourceURN, resourceURN, defVocContext, defVocScheme);
        }
        catch (MalformedURLException mURLe){
            System.out.println("Test: Feil i catalog");
            mURLe.printStackTrace();
        }
        return new Catalog(catalogHref,resource,topicUse, topicUseContext);
    }
    
    public TopicSet topicSetTest(){
        //Metoden kan returnere null, hvis en av URL med frer kasting  av MalformedURLException.
        TopicSet topicSet   = null;
        Catalog catalog     = null;
        URL resourceURN     = null;
        URL resourceURL     = null;
        Resource resource   = null;
        Topic topic         = null;
        String topicType    = "dette er en topicType";
        
        try {
            topic               = new Topic(topicType);
            topic.addComment("dette er en topic tilleggs kommentar");
            topic.addDescriptionMap("description EKSTRA");
            topic.addDescriptionMap("description EKSTRA", "description EKSTRA");
            topic.addProperty("property EKSTRA");
            topic.addTopicType("topicType EKSTRA");
            catalog = nyCatalog("TopicSet", "http:naaf.no/resouceURN.TopicCatalog","http:naaf.no/resouceURL.TopicCatalog",
                                "defVocContext.TopicCatalog", "defVocScheme.TopicCatalog","#person1","DescriptiveMetadata");
            
            //legger til en ekstra resource.
            resourceURN     = new URL("http:naaf.no/resouceURN/EKSTRA");
            resourceURL     = new URL("http:naaf.no/resouceURL/EKSTRA");
            resource        = new Resource(resourceURN, resourceURN, "defVocContext/EKSTRA", "defVocScheme/EKSTRA");
            resource.addDefVocMap("defVocContext EKSTRA 2");
            resource.addDefVocMap("defVocContext EKSTRA 2", "defVokSheme EKSTRA 2");
            URL resourceURLEkstra     = new URL("http:naaf.no/resouceURL/EKSTRA 2");
            resource.addUrl(resourceURLEkstra);
            catalog.addResousce(resource);
            //Legger til en ekstra TopicUseMap
            catalog.addTopicUseMap("TopicSet add topicUse","TopicSet add Topic");
            topicSet = new TopicSet("topicSetFormalName" , "TopicSet kommentar felt", catalog, "topicSetRef-felt", topic);
            topicSet.addComment("comment EKSTRA");
            Topic topicE = new Topic("topictype Ekstra");
            topicSet.addTopic(topicE);
            topicSet.addTopicSetRef("topicSetRef EKSTRA");
            
            
        }
        
        catch (MalformedURLException mURLe){
            System.out.println("Test: Status vokab.URL er feil");
            mURLe.printStackTrace();
        }
        return topicSet;
    }
    
    public NewsEnvelope newsEnvelopeTest(){
        //NewsEnvelope newsEnvelope = null;
        return new NewsEnvelope("20021120T1750+0100", "1");
        
    }
    /**
     *Tester om NewsItem Class virker etter planen.
     *
     */
    public void newsItemTest(){
        String comment                      = null;
        Catalog catalog                     = null;
        
        Resource resource                   = null;
        URL resourceURN                     = null;
        URL resourceURL                     = null;
        //NewsItemSub -> NewsComponent
        Catalog newsCompCatalog             = null;
        TopicSet newsCompTopicSet           = null;
        
        //Admin metadata variabler
        NewsLines newsLines                 = null;
        URL adminMetaSystemIdentifier       = null;
        AdminMetadata adminMetadata         = null;
        Catalog adminMetaCatalog            = null;
        
        //Rettighets metadata variabler
        RightsMetadata rightsMetadata       = null;
        Catalog rightCatalog                = null;
        
        //Beskrivende metadata variabler
        DescriptiveMetadata descriptMeta    = null;
        Catalog descriptCatalog             = null;
        URL topicOccurr                     = null;
        
        NewsComponent newsComponent         = null;
        TopicSet newsComTopicEkstra         = null;
        NewsItemSub newsItemSub             = null;
        NewsIdentifier newsIdentifier       = null;
        Identification identification       = null;
        URL newsCompSubRef                  = null;
        NewsComponentSub newsComponentSub   = null;
        //NewsMangaement variabler
        URL newsItemTypeVocabulary      = null;
        URL newsItemTypeScheme          = null;
        URL statusVok                   = null;
        URL statusSkjema                = null;
        URL urgencyVocabulary           = null;
        URL urgencyScheme               = null;
        URL derivedFrom                 = null;
        URL associatedWith              = null;
        URL instructionVocabulary       = null;
        //URL statusVok = null;
        //URL statusSkjema = null;
        //URL newsItemVok= null;
        //URL newsItemSkjema = null;
        NewsManagement newsManagement   = null;
        NewsItem newsItem = null;
        comment = "dette er commenten til selv newsItem objektet";
        
        
        try {
            resourceURN     = new URL("http:naaf.no/resouceURN");
            resourceURL     = new URL("http:naaf.no/resouceURL");
            resource        = new Resource(resourceURN, resourceURN, "defVocContext", "defVocScheme");
            catalog         = nyCatalog("http://NewsItemCatalog", "http:naaf.no/resouceURN.NewsItemCatalog",
                                        "http:naaf.no/resouceURL.NewsItemCatalog","defVocContext.NewsItemCatalog", 
                                        "defVocScheme.NewsItemCatalog","#person2", "DescriptiveMetadata");
            
            //////////////////////////////////////
            ///Oppretter NewsComponent////////////
            ////////////////////////////////////
            
            //Legger inn ny katalog
            newsCompCatalog     = nyCatalog("http://NewsCompCatalog", "http:naaf.no/resouceURN.NewsCompCatalog",
                                            "http:naaf.no/resouceURL.NewsCompCatalog","defVocContext.NewsCompCatalog",
                                            "defVocScheme.NewsCompCatalog","#person3", "DescriptiveMetadata");
            newsCompTopicSet    = topicSetTest();
            
            //Legger inn ny "newsLine"
            ArrayList newsLineText = new ArrayList();
            newsLineText.add("newsLine1");
            newsLineText.add( "newsLine2");
            newsLineText.add( "newsLine3");
            newsLines           =  new NewsLines("headLine","subHeadLine","byLine","dateLine","creditLine","copyrightLine",
            "rightsLine", "seriesLine", "slugLine", "keywordLine", "newsLinesType", newsLineText);
            //Legger inn ekstra newsLines
            newsLines.addByLine(" byLine EKSTRA");
            newsLines.addCopyrightLine("copyrightLine EKSTRA");
            newsLines.addCreditLine("creditLine EKSTRA");
            newsLines.addDateLine("dateLine EKSTRA");
            newsLines.addHeadLineMap("headLine EKSTRA ALENE");
            newsLines.addHeadLineMap("headLine  EKSTRA", "subheadline  EKSTRA");
            newsLines.addKeywordLine("keywordLine EKSTRA");
            ArrayList newsLineTextEkstra = new ArrayList();
            newsLineTextEkstra.add("newsLine1 EKSTRA");
            newsLineTextEkstra.add( "newsLine2 EKSTRA");
            newsLineTextEkstra.add( "newsLine3 EKSTRA");
            newsLines.addNewsLineMap("newsLineType Ekstra!" ,  newsLineTextEkstra);
            newsLines.addRightsLine("rightsLine  EKSTRA");
            newsLines.addSeriesLine("seriesLine EKSTRA");
            newsLines.addSlugLine("slugLine EKSTRA");
            
            //Legger inn administrative metadata
            adminMetaCatalog  = nyCatalog("http://AdminMetaCatalog", "http:naaf.no/resouceURN.AdminMetaCatalog",
                                            "http:naaf.no/resouceURL.AdminMetaCatalog","defVocContext.AdminMetaCatalog",
                                            "defVocScheme.AdminMetaCatalog","#person3", "DescriptiveMetadata");
            File adminFile = new File("c:" + SLASH + "testNewsItem.xml");
            adminMetaSystemIdentifier = new URL( "http://AdminMetasystemIdentifier");
            adminMetadata = new AdminMetadata(adminMetaCatalog, adminFile,adminMetaSystemIdentifier,
            "adminMetaprovider", "adminMetaCreator", "adminMetaSource", "adminMetaContributor", "adminMetaProperty");
            adminMetadata.addContributor("tilleggs contributor");
            adminMetadata.addProperty("tilleggs property");
            adminMetadata.addSource("Tilegges source");
            
            
            //legger inn rettighetsmetadata
            rightCatalog = nyCatalog("http://rightMetaCatalog", "http:naaf.no/resouceURN.rightMetaCatalog",
                                        "http:naaf.no/resouceURL.rightMetaCatalog","defVocContext.rightMetaCatalog", 
                                    "defVocScheme.rightMetaCatalog","#person3", "DescriptiveMetadata");
            ArrayList rmComment = new ArrayList();
            rmComment.add(" copyrightComment comment1");
            rmComment.add( "copyrightComment comment2");
            rmComment.add( "copyrightComment comment3");
            rightsMetadata = new RightsMetadata(rightCatalog,rmComment,"copyrightHolder","copyrightDate","usageType", "usageGeography",
            "usageRightsHolder", "usageLimitations", "usageStartDate", "usageEndDate", "property");
            
            rightsMetadata.addProperty("property EKSTRA");
            rightsMetadata.addCopyright("copyrightHolder EKSTRA", "copyrightData EKSTRA");
            
            //Catalog rightCatalogE = nyCatalog("http://rightMetaCatalog EKSTRA", "http:naaf.no/resouceURN.rightMetaCatalogEKSTRA",
            //"http:naaf.no/resouceURL.rightMetaCatalogEKSTRA","defVocContext.rightMetaCatalog/EKSTRA",
            //"defVocScheme.rightMetaCatalog.EKSTRA","#person3EKSTRA", "DescriptiveMetadata EKSTRA");
            //rightsMetadata.addCatalog(rightCatalogE);
            
            ArrayList rmCommentE = new ArrayList();
            rmCommentE.add(" copyrightComment comment1 EKSTRA2");
            rmCommentE.add( "copyrightComment comment2 EKSTRA2");
            rmCommentE.add( "copyrightComment comment3 EKSTRA2");
            rightsMetadata.addCopyright(rmCommentE, "copyrightHolder EKSTRA2", "copyrightData EKSTRA2");
            rightsMetadata.addUsageRights("usageEndDate EKSTRA", "usageGeography EKSTRA", "usageLimitations EKSTRA", 
                                        "usageRightsHolder EKSTRA", "usageStartDate EKSTRA","usageType EKSTRA");
            
            
            //Legger inn beskrivende metadata
            descriptCatalog = nyCatalog("http://descriptMetaCatalog", "http:naaf.no/resouceURN.descriptMetaCatalog",
                                        "http:naaf.no/resouceURL.descriptMetaCatalog","defVocContext.descriptMetaCatalog", 
                                        "defVocScheme.descriptMetaCatalog","#person3", "DescriptiveMetadata");
            topicOccurr = new URL("http://topicOccurrenceDuid");
            descriptMeta = new DescriptiveMetadata(descriptCatalog,  "language",  "genre",
            "subjectCode",  "ofInterestTo", topicOccurr,  "topicOccurrence","property");
            descriptMeta.addLanguage("language EKSTRA");
            descriptMeta.addOfInterestTo("ofInterestTo EKSTRA");
            descriptMeta.addProperty("property EKSTRA");
            descriptMeta.addSubjectCode("subjectCode EKSTRA");
            
            //Legger inn newsCompSub
            newsCompSubRef = new URL("http:naaf.no/newsCompSubRef ");
            newsComponentSub = new NewsComponentSub(newsCompSubRef);
            
            //lager et nytt newsComponent
            newsComponent   = new NewsComponent("no", "yes","NewsCompXmlLang", "NewsCom commet text",
            newsCompCatalog, newsCompTopicSet, "newsCompRole", "newsCompBasisForChoice", newsLines, adminMetadata,
            rightsMetadata, descriptMeta, "metadata", "metadataProperty", newsComponentSub);
            newsComponent.addBasisForChoice("basisForChoice EKSTRA");
            newsComponent.addComment("comment EKSTRA");
            newsComTopicEkstra = new TopicSet("NewsComTopicSet Ekstra");
            newsComTopicEkstra.addComment("newsComTopicEkstra");
            newsComponent.addTopicSet(newsComTopicEkstra);
            
            //Lager et nytt newsItemSub
            newsItemSub     = new NewsItemSub(newsComponent);
            
            
            //Lager et nytt newsIdentifier
            newsIdentifier  = new NewsIdentifier("naaf.no","19mai","43656.345","1", "0", "U", "kdjfgdh");
            identification  = new Identification(newsIdentifier, "NewsItem/Identifier/namelabel", "NewsItem/Identifier/datelabel", 
                                                "NewsItem/Identifier/datelabel/labelType", "NewsItem/Identifier/datelabel/labelText");
            identification.addLabel("NewsItem/Identifier/datelabel/labelType/EKSTRA", "NewsItem/Identifier/datelabel/labelText/EKSTRA");
            
            //setter NewsManagement Variablene.
            newsItemTypeVocabulary = new URL("http:naaf.no/newsItemTypeVocabulary");
            newsItemTypeScheme = new URL("http:naaf.no/newsItemTypeScheme");
            statusVok       = new URL("http:naaf.no/statusVok");
            statusSkjema    = new URL("http:naaf.no/stausSkjema");
            urgencyVocabulary = new URL("http:naaf.no/urgencyVocabulary");
            urgencyScheme = new URL("http:naaf.no/urgencyScheme");
            //newsItemVok     = new URL("http:naaf.no/newsItemVok");
            //newsItemSkjema  = new URL("http:naaf.no/newsItemSkjema");
            derivedFrom  = new URL("http:naaf.no/derivedFrom");
            associatedWith = new URL("http:naaf.no/associatedWith");
            instructionVocabulary = new URL("http:naaf.no/instructionVocabulary");
            newsManagement  = new NewsManagement("NewsItemType",newsItemTypeVocabulary, newsItemTypeScheme,
            "first created", "thisRevisionCreated", "Status", statusVok, statusSkjema, "futureStatus",
            "dateAndTime", "urgency", urgencyVocabulary, urgencyScheme, "revisionHistory",derivedFrom, associatedWith,
            "instruction", instructionVocabulary, "propertyFormalname", "propertyAssignment");
            
            URL associatedWithEkstra = new URL("http:naaf.no/associatedWithEkstra");
            URL derivedFromEkstra = new URL("http:naaf.no/derivedFromEkstra");
            newsManagement.addAssociatedWith(associatedWithEkstra);
            newsManagement.addDerivedFrom(derivedFromEkstra);
            newsManagement.addInstructionMap("instruction EKSTRA ALENE");
            URL instructVocabEkstra = new URL("http:naaf.no/instructVocabEkstra");
            newsManagement.addInstructionMap( "instruction EKSTRA", instructVocabEkstra);
            newsManagement.addPropertyMap("propertyFormalname EKSTRA");
            newsManagement.addPropertyMap("propertyFormalname EKSTRA", "property ass EKSTRA");
            
            // this.newsItemType           = newsItemType;
            // newsItemSub     = new NewsItemSub(newsItemSubUpdate);
            
            // Da er alle objekt instansiert, klar til  instansiere NewsItem
            newsItem = new NewsItem("newsItem kommentar", catalog, identification, newsManagement, newsItemSub);
            newsItem.addComment("dette er en EKSTRA newsItem comment");
            // Legger inn en ny hoved katalog
            Catalog hovedCatalog = nyCatalog("http://TopicUse", "http:naaf.no/resouceURN.HovedCatalog","http:naaf.no/resouceURL.HovedCatalog",
                                            "defVocContext.HovedCatalog", "defVocScheme.HovedCatalog","#person1", "DescriptiveMetadata");
            //Legger inn en ny hoved topicSet
            TopicSet hovedTopicSet = topicSetTest();
            //Legger inn en ny nyhets konvolutt
            NewsEnvelope newsEnvelope = newsEnvelopeTest();
            //Kaller metoden som skriver det hele til fil.
            writeNewsItem("c:" + SLASH + "testNewsItem.xml",hovedCatalog, hovedTopicSet, newsEnvelope, newsItem);
            
        }
        catch (MalformedURLException mURLe){
            System.out.println("Test: Status vokab.URL er feil");
            mURLe.printStackTrace();
        }
        
    }
    
    public void writeNewsItem(String filename, Catalog catalog, TopicSet topicSet, NewsEnvelope newsEnvelope, NewsItem newsItem){
        try {
            File file = new File(filename);
            file.createNewFile(); // Oppretter ein ny fil, sletter ein evt. eksisterande.
            BufferedWriter bw = new BufferedWriter(new FileWriter(file));
            bw.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + LF);
            bw.write("<!DOCTYPE NewsML SYSTEM \"NewsML.dtd\">" + LF);
            bw.write("<?xml-stylesheet type=\"text/xsl\" href=\"NAAF.xsl\"?>" + LF);
            bw.write("<NewsML>" + LF);
            bw.write(catalog.getCatalog());
            bw.write(topicSet.getTopicSet());
            bw.write(newsEnvelope.getNewsEnvelope());
            bw.write(newsItem.getNewsItem());
            bw.write("</NewsML>" + LF);
            bw.flush(); // Tmmer bufferen ut p fila
            bw.close(); // Stenger fila
            System.out.println("Ferdig med filbehandling i Test, sjekk " + file.getPath());
        }
        catch (Exception e) {
            System.out.println("Noko gjekk galt i Test...");
            e.printStackTrace();
        }
    }
    
    public void skrivObjektTilFil(File file, NewsML newsML){
        try{
            ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(file));
            oos.writeObject(newsML);
            oos.close();
        }
        catch (IOException ioe){
            ioe.printStackTrace();
        }
        catch (Exception e){
            e.printStackTrace();
        }
        
    }
    
    public NewsML lesObjektFraFil(File file){
        NewsML temp = null;
        try{
            ObjectInputStream ois = new ObjectInputStream(new FileInputStream(file));
        //    temp = ois.readObject();
            ois.close();
        }
        catch (IOException ioe){
            ioe.printStackTrace();
        }
        catch (Exception e){
            e.printStackTrace();
        }
        return temp;
    }
    
}
