package no.ingeberg.newsMLGrensesnitt;
import org.xmldb.api.base.*;
import org.xmldb.api.modules.*;
import org.xmldb.api.*;
import java.io.*;
import no.ingeberg.newsMLGrensesnitt.tools.*;



/**
 *Legger inn valgte fil inn i databasen i en xindice database (brukes ikke til exist). Det blir ikke testet om dokumentet finnes i
 *databasen fra fr.
 */
public class AddDocument {
    private AdminBaseGUI opner = null;
    
    public AddDocument(java.io.File file, AdminBaseGUI opner, ConnectDB myConnection){
        // Legger inn den aktuelle fila i "file" inn i databasen som er koblet med "myConnection"
        //Sjekker om alle essensielle variabler er satt.
        if ((file!=null) && (opner !=null) && (myConnection !=null)) {
            try {
                // legger inn fila i databasen
                this.opner = opner;
                Collection col = myConnection.getCol();
                System.out.println("Document " + file.getName() + " er valgt");
                String data = readFileFromDisk(file.getPath());
                XMLResource document = (XMLResource) col.createResource(null,"XMLResource");
                document.setContent(data);
                col.storeResource(document);
                System.out.println("Document " + file.getName() + " inserted");
            }
            catch (XMLDBException xmldbExc) {
                System.err.println("XML:DB Exception occured i AddDocument klassa: " + xmldbExc.errorCode);
               xmldbExc.printStackTrace();
            }
            catch (Exception e) {
                System.err.println("Exception occured i AddDocument klassa:" + e.toString());
                e.printStackTrace();
            }
        }
        else {
            //gir feilmelding og avslutter da essensielle variabler ikke er satt
            System.out.println("Ugyldig parameter");
            return;
        }
        
    }
    
    public String readFileFromDisk(String fileName) throws Exception {
        File file = new File(fileName);
        FileInputStream insr = new FileInputStream(file);
        byte[] fileBuffer = new byte[(int)file.length()];
        insr.read(fileBuffer);
        insr.close();
        return new String(fileBuffer);
    }
}
