/*
 * AdminBaseGUI.java
 *
 *Klassen innholder grensesnittet i systemet, lager ogs NewsML dokumentet
 *
 */

package no.ingeberg.newsMLGrensesnitt;
import java.io.File;
import javax.swing.*;
import java.util.*;
import java.text.*;
import no.ingeberg.NewsML.*;
import no.ingeberg.newsMLGrensesnitt.tools.*;
import no.ingeberg.newsmldb.*;
import no.ingeberg.newsmldb.MyDerbyDB;
//import org.apache.xmlrpc.XmlRpc;

public class AdminBaseGUI extends javax.swing.JFrame {
    // Navn p skjembilder
    public final int SKJERMBILDE_SENTERPANEL = 1;
    public final int SKJERMBILDE_NEWSMANAGEMENT = 2;
    public final int SKJERMBILDE_NEWSCOMPONENT = 3;
    public final int SKJERMBILDE_CONTENTITEM = 4;
    public final int SKJERMBILDE_NEWSLINES = 5;
    int aktivtSkjermbilde = SKJERMBILDE_SENTERPANEL;
    int nesteSkjermbilde = SKJERMBILDE_SENTERPANEL;
    
    public String PROVIDER_ID = "naaf.no";
    //private ConnectDB myConnection = null;
    private MyDerbyDB db;
    private LagNyArt myData;
    private Kalender kalender;
    private int komponentteller = 0;
    private NewsML newsML = null;  // DETTE ER MLET MED PROGRAMMET!
    private TopicSet topicSet               = null;
    private NewsManagement newsManagement   = null;
    private Identification identification   = null;
    private ContentItem contentItem         = null;
    private AdminMetadata adminMetadata     = null;
    private NewsComponent newsComponent     = null;
    private NewsEnvelope newsEnvelope       = null;
    private NewsItem newsItem               = null;
    private no.ingeberg.NewsML.NewsLines newsLines = null;
    //Alle delskjema
    // private Admin.ExternalApplication database = null;
    
    /** Creates new form AdminBaseGUI */
    public AdminBaseGUI() {
        initComponents();
        myInit();
        pack();
    }
    
    private void myInit() {
        //String s = (String) JOptionPane.showInputDialog(this,"Tekst", "Title", JOptionPane.YES_NO_OPTION);
        
        // Initialisering av div dill og dall
        //  String[] streng = {"c:\\work\\Xindice\\startup.bat"};
        //  database = new Admin.ExternalApplication(streng);
        //  myConnection = new ConnectDB();
        
        initNewArt1(); // 1. skjermbilde
        initNewArt2(); // 2. skjermbilde
        //initNewArt3(); // 3. skjermbilde
        //initNewArt4(); // 4. skjermbilde
        //initNewArt5(); // 5. skjermbilde
        initNewArt6(); // 6. skjermbilde
        //initNewArt7(); // 7. skjermbilde
        initSeachArt(); // sk skjermbilde
        db = new MyDerbyDB();   // Starter/oppretter databasen som lagrer binr data
    }
    
    private void avslutt() {
        try {
            db.close();
        }
        catch (Exception e) { /* IGNORE */ }
        System.exit(0);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        nyArtNewsManagement = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel15 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel16 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        firstCreatedField = new javax.swing.JTextField();
        thisRevisionCreatedField = new javax.swing.JTextField();
        nyStatusTidField = new javax.swing.JTextField();
        newsItemTypeField = new javax.swing.JComboBox();
        jLabel27 = new javax.swing.JLabel();
        statusField = new javax.swing.JComboBox();
        nyStatusField = new javax.swing.JComboBox();
        urgencyField = new javax.swing.JComboBox();
        jButton7 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        jButton9 = new javax.swing.JButton();
        jLabel64 = new javax.swing.JLabel();
        jLabel63 = new javax.swing.JLabel();
        revisjonsIdField = new javax.swing.JComboBox();
        nameLabelField = new javax.swing.JTextField();
        nyArtNewsComponent = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jLabel25 = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jLabel26 = new javax.swing.JLabel();
        commentField = new javax.swing.JTextField();
        jLabel28 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jLabel31 = new javax.swing.JLabel();
        creatorField = new javax.swing.JTextField();
        jLabel32 = new javax.swing.JLabel();
        sourceField = new javax.swing.JTextField();
        jPanel7 = new javax.swing.JPanel();
        nyArtNewsLines = new javax.swing.JPanel();
        jLabel49 = new javax.swing.JLabel();
        jLabel50 = new javax.swing.JLabel();
        jLabel51 = new javax.swing.JLabel();
        jLabel52 = new javax.swing.JLabel();
        jLabel53 = new javax.swing.JLabel();
        jLabel54 = new javax.swing.JLabel();
        jLabel55 = new javax.swing.JLabel();
        sluglineField = new javax.swing.JTextField();
        headlineField = new javax.swing.JTextField();
        subheadlineField = new javax.swing.JTextField();
        bylineField = new javax.swing.JTextField();
        creditlineField = new javax.swing.JTextField();
        rightslineField = new javax.swing.JTextField();
        serieslineField = new javax.swing.JTextField();
        jLabel56 = new javax.swing.JLabel();
        keywordlineField = new javax.swing.JTextField();
        nyArtContentItem = new javax.swing.JPanel();
        jLabel40 = new javax.swing.JLabel();
        contentCommentField = new javax.swing.JTextField();
        jLabel42 = new javax.swing.JLabel();
        mediaTypeFNComboBox = new javax.swing.JComboBox();
        jLabel43 = new javax.swing.JLabel();
        formatFNComboBox = new javax.swing.JComboBox();
        jLabel44 = new javax.swing.JLabel();
        mimeTypeFNComboBox = new javax.swing.JComboBox();
        jLabel45 = new javax.swing.JLabel();
        sizeInBytesField = new javax.swing.JTextField();
        jLabel48 = new javax.swing.JLabel();
        jButton3 = new javax.swing.JButton();
        valgteFiler = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        leggInnFilPanel = new javax.swing.JPanel();
        jButton2 = new javax.swing.JButton();
        nyArtPanel = new javax.swing.JPanel();
        ledetekstPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        knappePanel = new javax.swing.JPanel();
        nyArtPanelAvsluttButton = new javax.swing.JButton();
        nyArtPanelNesteButton = new javax.swing.JButton();
        nyArtSenterPanel1 = new javax.swing.JPanel();
        jLabel46 = new javax.swing.JLabel();
        jLabel60 = new javax.swing.JLabel();
        jLabel61 = new javax.swing.JLabel();
        topicComField = new javax.swing.JTextField();
        topicDesField = new javax.swing.JTextField();
        topicTypeField = new javax.swing.JComboBox();
        sokPanel = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        fileNameField = new javax.swing.JTextField();
        jTextField16 = new javax.swing.JTextField();
        jButton4 = new javax.swing.JButton();
        jButton13 = new javax.swing.JButton();
        seachelementField = new javax.swing.JComboBox();
        jSeparator1 = new javax.swing.JSeparator();
        feedbackPanel = new javax.swing.JPanel();
        feedbackLabel = new javax.swing.JLabel();
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        openMenuItem = new javax.swing.JMenuItem();
        saveMenuItem = new javax.swing.JMenuItem();
        saveAsMenuItem = new javax.swing.JMenuItem();
        exitMenuItem = new javax.swing.JMenuItem();
        editMenu = new javax.swing.JMenu();
        cutMenuItem = new javax.swing.JMenuItem();
        copyMenuItem = new javax.swing.JMenuItem();
        pasteMenuItem = new javax.swing.JMenuItem();
        deleteMenuItem = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        contentsMenuItem = new javax.swing.JMenuItem();
        aboutMenuItem = new javax.swing.JMenuItem();

        nyArtNewsManagement.setLayout(new java.awt.BorderLayout());

        nyArtNewsManagement.setName("nyArtNewsManagement");
        jLabel15.setText("Legg inn forvaltnings informasjon om nyhetsposten");
        jPanel2.add(jLabel15);

        nyArtNewsManagement.add(jPanel2, java.awt.BorderLayout.NORTH);

        jPanel4.setLayout(new java.awt.GridBagLayout());

        jLabel16.setText("Nyhetspostens type* ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 0, 0);
        jPanel4.add(jLabel16, gridBagConstraints);

        jLabel17.setText("F\u00f8rst laget *");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(jLabel17, gridBagConstraints);

        jLabel18.setText("Denne versjonene laget *");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(jLabel18, gridBagConstraints);

        jLabel19.setText("Status *");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(jLabel19, gridBagConstraints);

        jLabel20.setText("Status vil bli endret");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(jLabel20, gridBagConstraints);

        jLabel21.setText("Viktighet");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(jLabel21, gridBagConstraints);

        firstCreatedField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(firstCreatedField, gridBagConstraints);

        thisRevisionCreatedField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(thisRevisionCreatedField, gridBagConstraints);

        nyStatusTidField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(nyStatusTidField, gridBagConstraints);

        newsItemTypeField.setPreferredSize(new java.awt.Dimension(120, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(newsItemTypeField, gridBagConstraints);

        jLabel27.setText("ny status.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(jLabel27, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(statusField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(nyStatusField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(urgencyField, gridBagConstraints);

        jButton7.setText("...");
        jButton7.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(jButton7, gridBagConstraints);

        jButton8.setText("...");
        jButton8.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(jButton8, gridBagConstraints);

        jButton9.setText("...");
        jButton9.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton9ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 1, 0);
        jPanel4.add(jButton9, gridBagConstraints);

        jLabel64.setText("Navngielse av nyhetsposten");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        jPanel4.add(jLabel64, gridBagConstraints);

        jLabel63.setText("Revisjons id *");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(jLabel63, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(revisjonsIdField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(nameLabelField, gridBagConstraints);

        nyArtNewsManagement.add(jPanel4, java.awt.BorderLayout.CENTER);

        nyArtNewsComponent.setLayout(new java.awt.BorderLayout());

        nyArtNewsComponent.setName("nyArtNewsComponent");
        jLabel25.setText("Legg inn informasjon om nyhetskomponenten.");
        jPanel5.add(jLabel25);

        nyArtNewsComponent.add(jPanel5, java.awt.BorderLayout.NORTH);

        jPanel6.setLayout(new java.awt.GridBagLayout());

        jLabel26.setText("kommentar(frivillig)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel6.add(jLabel26, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel6.add(commentField, gridBagConstraints);

        jLabel28.setText("Legg inn newslines");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel6.add(jLabel28, gridBagConstraints);

        jButton1.setText("NewsLines");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel6.add(jButton1, gridBagConstraints);

        jLabel31.setText("Forfatter");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel6.add(jLabel31, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel6.add(creatorField, gridBagConstraints);

        jLabel32.setText("Kilde");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel6.add(jLabel32, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        jPanel6.add(sourceField, gridBagConstraints);

        nyArtNewsComponent.add(jPanel6, java.awt.BorderLayout.CENTER);

        nyArtNewsComponent.add(jPanel7, java.awt.BorderLayout.SOUTH);

        nyArtNewsLines.setLayout(new java.awt.GridBagLayout());

        jLabel49.setText("Headline");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(jLabel49, gridBagConstraints);

        jLabel50.setText("Subheadline");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(jLabel50, gridBagConstraints);

        jLabel51.setText("Byline");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(jLabel51, gridBagConstraints);

        jLabel52.setText("Creditline");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(jLabel52, gridBagConstraints);

        jLabel53.setText("Rightsline");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(jLabel53, gridBagConstraints);

        jLabel54.setText("Series line");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(jLabel54, gridBagConstraints);

        jLabel55.setText("Slug line");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(jLabel55, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(sluglineField, gridBagConstraints);

        headlineField.setPreferredSize(new java.awt.Dimension(110, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(headlineField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(subheadlineField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(bylineField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(creditlineField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(rightslineField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(serieslineField, gridBagConstraints);

        jLabel56.setText("Keyword Line");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtNewsLines.add(jLabel56, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        nyArtNewsLines.add(keywordlineField, gridBagConstraints);

        nyArtContentItem.setLayout(new java.awt.GridBagLayout());

        jLabel40.setText("Kommentar");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 3;
        gridBagConstraints.ipady = 6;
        nyArtContentItem.add(jLabel40, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtContentItem.add(contentCommentField, gridBagConstraints);

        jLabel42.setText("Media type");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtContentItem.add(jLabel42, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtContentItem.add(mediaTypeFNComboBox, gridBagConstraints);

        jLabel43.setText("Format");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtContentItem.add(jLabel43, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtContentItem.add(formatFNComboBox, gridBagConstraints);

        jLabel44.setText("Mimetype");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtContentItem.add(jLabel44, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtContentItem.add(mimeTypeFNComboBox, gridBagConstraints);

        jLabel45.setText("St\u00f8rrelse i bytes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtContentItem.add(jLabel45, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        nyArtContentItem.add(sizeInBytesField, gridBagConstraints);

        jLabel48.setText("Innholds element");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 17;
        nyArtContentItem.add(jLabel48, gridBagConstraints);

        jButton3.setText("Browse");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 17;
        gridBagConstraints.ipady = 1;
        gridBagConstraints.insets = new java.awt.Insets(2, 3, 3, 3);
        nyArtContentItem.add(jButton3, gridBagConstraints);

        valgteFiler.setLayout(new javax.swing.BoxLayout(valgteFiler, javax.swing.BoxLayout.Y_AXIS));

        valgteFiler.setBorder(javax.swing.BorderFactory.createTitledBorder("Opplasta filer: "));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 27;
        nyArtContentItem.add(valgteFiler, gridBagConstraints);
        valgteFiler.getAccessibleContext().setAccessibleName("Opplasta filer:      ");

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jButton2.setText("Browse...");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        leggInnFilPanel.add(jButton2);

        jTabbedPane1.addTab("legg inn artikkel", leggInnFilPanel);

        nyArtPanel.setLayout(new java.awt.BorderLayout());

        ledetekstPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        ledetekstPanel.setName("ledetekstPanel");
        jLabel1.setText("Legg inn informasjon om artikkelens emne");
        ledetekstPanel.add(jLabel1);

        nyArtPanel.add(ledetekstPanel, java.awt.BorderLayout.NORTH);

        knappePanel.setLayout(new java.awt.BorderLayout());

        knappePanel.setName("knappePanel");
        nyArtPanelAvsluttButton.setText("Avslutt");
        nyArtPanelAvsluttButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nyArtPanelAvsluttButtonActionPerformed(evt);
            }
        });

        knappePanel.add(nyArtPanelAvsluttButton, java.awt.BorderLayout.WEST);

        nyArtPanelNesteButton.setText("Neste");
        nyArtPanelNesteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nyArtPanelNesteButtonActionPerformed(evt);
            }
        });

        knappePanel.add(nyArtPanelNesteButton, java.awt.BorderLayout.EAST);

        nyArtPanel.add(knappePanel, java.awt.BorderLayout.SOUTH);

        nyArtSenterPanel1.setLayout(new java.awt.GridBagLayout());

        nyArtSenterPanel1.setName("nyArtSenterPanel1");
        jLabel46.setText("Kommentar til emnet");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        nyArtSenterPanel1.add(jLabel46, gridBagConstraints);

        jLabel60.setText("Emne Type *");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        nyArtSenterPanel1.add(jLabel60, gridBagConstraints);

        jLabel61.setText("Beskrivelse av emnet");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        nyArtSenterPanel1.add(jLabel61, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        nyArtSenterPanel1.add(topicComField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        nyArtSenterPanel1.add(topicDesField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        nyArtSenterPanel1.add(topicTypeField, gridBagConstraints);

        nyArtPanel.add(nyArtSenterPanel1, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("lag ny artikkel", null, nyArtPanel, "null");

        sokPanel.setLayout(new java.awt.GridBagLayout());

        jLabel7.setFont(new java.awt.Font("MS Sans Serif", 1, 14));
        jLabel7.setText("S\u00f8k etter artikkel");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
        sokPanel.add(jLabel7, gridBagConstraints);

        jLabel8.setText("S\u00f8k etter filnavn");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        sokPanel.add(jLabel8, gridBagConstraints);

        jLabel9.setText("S\u00f8k med kriterier");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        sokPanel.add(jLabel9, gridBagConstraints);

        fileNameField.setMinimumSize(new java.awt.Dimension(11, 75));
        fileNameField.setPreferredSize(new java.awt.Dimension(75, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        sokPanel.add(fileNameField, gridBagConstraints);

        jTextField16.setPreferredSize(new java.awt.Dimension(75, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 3;
        sokPanel.add(jTextField16, gridBagConstraints);

        jButton4.setText("S\u00f8k");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        sokPanel.add(jButton4, gridBagConstraints);

        jButton13.setText("S\u00f8k");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        sokPanel.add(jButton13, gridBagConstraints);

        seachelementField.setPreferredSize(new java.awt.Dimension(75, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        sokPanel.add(seachelementField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(6, 0, 6, 0);
        sokPanel.add(jSeparator1, gridBagConstraints);

        jTabbedPane1.addTab("S\u00f8k", sokPanel);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.NORTH);

        feedbackPanel.add(feedbackLabel);

        getContentPane().add(feedbackPanel, java.awt.BorderLayout.SOUTH);

        fileMenu.setText("File");
        openMenuItem.setText("Open");
        fileMenu.add(openMenuItem);

        saveMenuItem.setText("Save");
        fileMenu.add(saveMenuItem);

        saveAsMenuItem.setText("Save As ...");
        fileMenu.add(saveAsMenuItem);

        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        editMenu.setText("Edit");
        cutMenuItem.setText("Cut");
        editMenu.add(cutMenuItem);

        copyMenuItem.setText("Copy");
        editMenu.add(copyMenuItem);

        pasteMenuItem.setText("Paste");
        editMenu.add(pasteMenuItem);

        deleteMenuItem.setText("Delete");
        editMenu.add(deleteMenuItem);

        menuBar.add(editMenu);

        helpMenu.setText("Help");
        contentsMenuItem.setText("Contents");
        helpMenu.add(contentsMenuItem);

        aboutMenuItem.setText("About");
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        setJMenuBar(menuBar);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-408)/2, (screenSize.height-188)/2, 408, 188);
    }// </editor-fold>//GEN-END:initComponents
    
    private void nyArtPanelAvsluttButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nyArtPanelAvsluttButtonActionPerformed
        avslutt();
    }//GEN-LAST:event_nyArtPanelAvsluttButtonActionPerformed
    
    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // Lokaliser innholds fil.
        JFileChooser filvelger = new javax.swing.JFileChooser();
        filvelger.setApproveButtonText("Velg");
        filvelger.setDialogTitle("Lokaliser innholdselement fil");
        filvelger.setFileSelectionMode(JFileChooser.FILES_ONLY);
        int returnVal = filvelger.showOpenDialog(new JFrame());
        //legger fila til i NewsML databasen eller gir feilmelding
        if (returnVal == JFileChooser.APPROVE_OPTION){
            // MySQLsaveFile br instansieres globalt ved initalisering av applikasjonen
            // og stenges nr applikasjonen avsluttes.
            //MySQLsaveFile db = new MySQLsaveFile();
            //db.addFile(filvelger.getSelectedFile());
            //db.close();
            int primaryKey = 0;
            try {
                File file = filvelger.getSelectedFile();
                primaryKey = db.saveFile(file);
                setPrimaryKeyInXML(primaryKey, file.getName());
            } catch (Exception ex) {
                ex.printStackTrace();
            }
         //   feedbackLabel.setText("Fila er lagra med primrnkkel = " + new Integer(primaryKey).toString());
            
            valgteFiler.add(new JLabel(filvelger.getSelectedFile().getName()));
            pack();
            
        } else feedbackLabel.setText("Du m velge en fil for  fortsette.");
        
    }//GEN-LAST:event_jButton3ActionPerformed
    
    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        // TODO add your handling code here:
        //   new RetrieveExist(fileNameField.getText());
        try{
            RetrieveExist re = new RetrieveExist(fileNameField.getText());
        } catch (Exception e) { System.out.println("Noe gjekk feil : " + e.toString());
        }
        
    }//GEN-LAST:event_jButton4ActionPerformed
    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        aktivtSkjermbilde = SKJERMBILDE_NEWSLINES;
        skjermbildelogikk();
    }//GEN-LAST:event_jButton1ActionPerformed
/*
    class NewsLines extends javax.swing.JFrame {
        public NewsLines(JPanel panel) {
            getContentPane().setLayout(new java.awt.BorderLayout());
            getContentPane().add(panel, java.awt.BorderLayout.CENTER);
            pack();
        }
    }
 */
    private void jButton9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton9ActionPerformed
        // Add your handling code here:
        if (kalender == null){
            kalender = new Kalender(this,nyStatusTidField);
            kalender.setVisible(true);
        }
    }//GEN-LAST:event_jButton9ActionPerformed
    
    private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
        // Add your handling code here:
        if (kalender == null){
            kalender = new Kalender(this,thisRevisionCreatedField);
            kalender.setVisible(true);
        }
    }//GEN-LAST:event_jButton8ActionPerformed
    
    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        // Add your handling code here:
        if (kalender == null){
            kalender = new Kalender(this, firstCreatedField);
            kalender.setVisible(true);
        }
    }//GEN-LAST:event_jButton7ActionPerformed
    
    private void setPrimaryKeyInXML(int primaryKey, String fileName) {
        // Ta vare p denne nkkelen i XML fila, samt navnet p fila (inc. etternavn)
    }
    
    public void setDato(String dato, JTextField navn){
        if (kalender != null){
            navn.setText(dato);
            kalender.setVisible(false);
            kalender = null;
        }
    }
    
    /**
     * Returnerer et Identification object, det kan vre null ved database problem.
     */
    private Identification doIdentification() {
        //Les inn alle data fra sine respektive felt p GUI
        String nameLabel        = nameLabelField.getText();
        String revisjonsId      = (String)revisjonsIdField.getSelectedItem(); //obl
        SimpleDateFormat temp   = new SimpleDateFormat( "dd.MM.yy" );
        String dateId           = temp.toString();
        //String newsItemId       = "0";
        
        //Generer en unik id til nyhetsposten og viser denne
        
        int identifikasjonsId   = new MyDerbyDB().makeId();
        if (identifikasjonsId > 0){
            String newsItemId  = new Integer(identifikasjonsId).toString();
            System.out.println("identifikasjonsid er:" + new Integer(identifikasjonsId).toString());
            
            //PublicIdentifier =urn:newsml:{ProviderId}:{DateId}:{NewsItemId}:{RevisionId}{RevisionId@Update}
            String publicIdentifier = "urn:newsml:" + PROVIDER_ID + ":" + dateId + ":" + newsItemId + ":" + revisjonsId + ":" + "peker";
            String previousRevision = "Temp"; //Skal trekke fra 1 fra revisjonsId
            
            // Setter her update til N siden de i prinsippet ikke er laget sttte for  kunne oppdatere element.
            String update           = "N";
            
            //Oppretter "identification", som inneheld "NewsIdentifier"
            return new Identification(new NewsIdentifier(PROVIDER_ID, dateId, newsItemId, revisjonsId, previousRevision, 
                                                        update, publicIdentifier));
        } else {
            // Her er ikke ny id generert
        }
        return (Identification) null;
    }
    
    private NewsML lagNewsML(){
        //Oppretter et NewsItem Objekt.
        newsItem = new NewsItem(identification, newsManagement,(new NewsItemSub(newsComponent)));
        newsEnvelope = new NewsEnvelope(getDateAndTime());
        // Oppretter et nytt NewsML Objekt, da vi skal ha all relevant info
        return new NewsML(newsEnvelope, newsItem);
        //
    }
    private String getDateAndTime(){
        SimpleDateFormat datoForm=new SimpleDateFormat("yyyyMMdd");
        SimpleDateFormat tidsForm=new SimpleDateFormat("HHmm");
        Date dato = new Date();
        return datoForm.format(dato) + "T" + tidsForm.format(dato) + "+0" +
                new Integer(TimeZone.getDefault().getDSTSavings()/36000).toString();
    }
    
    private void skjermbildelogikk() {
        
        switch (nesteSkjermbilde) {
            case SKJERMBILDE_SENTERPANEL: {
                //Tester innkommende data
                if ((String)topicTypeField.getSelectedItem() != "") {
                    //Henter verdier fra GUI og lager topicSet elemenet i NewsML dokumenet
                    topicSet = new TopicSet(new Topic(topicComField.getText(), (String)topicTypeField.getSelectedItem(), 
                                            topicDesField.getText(), "xml:lang=\"no\""));
                    //Oppdaterer skjermbildet
                    nyArtPanel.remove(nyArtSenterPanel1);
                    System.out.println(" fjerner SenterP ");
                    nyArtPanel.add(nyArtNewsManagement, java.awt.BorderLayout.CENTER);
                    System.out.println("legger til NewsMang");
                    nesteSkjermbilde = SKJERMBILDE_NEWSMANAGEMENT;
                } else {
                    JOptionPane.showMessageDialog( null, "Skriv inn alle felt merket med  *");
                    nesteSkjermbilde = SKJERMBILDE_SENTERPANEL;
                }
                //Setter status
                break;
            }
            case SKJERMBILDE_NEWSMANAGEMENT: {
                //Tester innkommende data
                if (((String)revisjonsIdField.getSelectedItem() != ""))
                    //&& ((String)newsItemTypeField.getSelectedItem() != "")
                    //&& ((String)firstCreatedField.getText()!= null) && (thisRevisionCreatedField.getText() != null) && 
                    //        ((String)statusField.getSelectedItem() != ""))
                {
                    //Setter sammen newsManagement elementet i NewsML dokumentet
                    newsManagement = new NewsManagement((String)newsItemTypeField.getSelectedItem(), firstCreatedField.getText(),
                            thisRevisionCreatedField.getText(), (String)statusField.getSelectedItem(), (String)nyStatusField.getSelectedItem(),
                            nyStatusTidField.getText(), (String)urgencyField.getSelectedItem());
                    ///Tester og setter sammen identification elementet i NewsML dokumentet
                    identification = doIdentification();
                    //Skifter skjermbilde
                    nyArtPanel.remove(nyArtNewsManagement);
                    System.out.println(" fjerner NewsManage ");
                    nyArtPanel.add(nyArtNewsComponent, java.awt.BorderLayout.CENTER);
                    System.out.println("legger til NewComp");
                    nesteSkjermbilde = SKJERMBILDE_NEWSCOMPONENT;
                } else {
                    JOptionPane.showMessageDialog( null, "Skriv inn alle felt merket med  *");
                    nesteSkjermbilde = SKJERMBILDE_NEWSMANAGEMENT;
                }
                //setter status
                break;
            }
            
            
            case SKJERMBILDE_NEWSCOMPONENT: {
                //Les inn alle data fra sine respektive felt p GUI og danner admiinMetadata og newsComponent elemeneter i NewsML dokumenet
                String comment = commentField.getText();
                adminMetadata = new AdminMetadata(creatorField.getText(), sourceField.getText());
                newsComponent = new NewsComponent(commentField.getText(), newsLines, adminMetadata, (new NewsComponentSub(contentItem)));
                //Skifter skjermbilde og setter status
                nyArtPanel.remove(nyArtNewsComponent);
                System.out.println(" fjerner NewsComp");
                if (aktivtSkjermbilde == SKJERMBILDE_NEWSLINES){
                    nyArtPanel.add(nyArtNewsLines, java.awt.BorderLayout.CENTER);
                    System.out.println("legger til NewsLine");
                    nesteSkjermbilde = SKJERMBILDE_NEWSLINES;
                } else {
                    nyArtPanel.add(nyArtContentItem, java.awt.BorderLayout.CENTER);
                    System.out.println("legger til ContentItem");
                    nesteSkjermbilde = SKJERMBILDE_CONTENTITEM;
                }
                break;
            }
            
            case SKJERMBILDE_CONTENTITEM: {
                // @todo
                String innholdsurl = "temp"; //NB denne er fiktiv!!!!!!
                // Valider at dataene stemmer evt. nekt  g vidare, gi feilmelding etc.
                if (innholdsurl != null) {
                    Catalog catalog = new Catalog(new Resource()); //legger til et tomt catalog element
                    contentItem = new ContentItem(contentCommentField.getText(), catalog,
                            (String)mediaTypeFNComboBox.getSelectedItem(), (String)formatFNComboBox.getSelectedItem(),
                            (String)mimeTypeFNComboBox.getSelectedItem(), sizeInBytesField.getText(), innholdsurl, true);
                }
                aktivtSkjermbilde = SKJERMBILDE_CONTENTITEM;
                
                int valg = JOptionPane.showConfirmDialog(this, "nsker du  legge flere versoner av artikkelen? " +
                                                        "(nei vil lagre innlagt data i databasen)", "Title", JOptionPane.YES_NO_OPTION);
                
                if (valg == JOptionPane.CLOSED_OPTION) {
                    // Brukeren har stengt dilog vinduet
                } else if ( valg == JOptionPane.NO_OPTION) {
                    // Brukeren har besvart sprsmlet med "NO"
                    String filpalassering = "c:\\testNewsML.xml";
                    newsML = lagNewsML();
                    newsML.writeNewsML(filpalassering,null);
                    Put put = new Put(filpalassering);
                    //int filId   = new MyDerbyDB().makeId();
                    //if (filId > 0){  }
                    avslutt();                  
                    
                    //"<!DOCTYPE NewsML SYSTEM \"http:\\www.bibsys.no\NewsML.dtd\">""
                } else if ( valg == JOptionPane.YES_OPTION) {
                    // Brukeren har besvart sprsmlet med "YES"
                    //Skifter skjermbilde til nyArtContentItem og setter status.
                    nyArtPanel.remove(nyArtContentItem);
                    System.out.println(" fjerner ContentImen ");
                    nyArtPanel.add(nyArtNewsComponent, java.awt.BorderLayout.CENTER);
                    System.out.println("legger til NewComp ");
                    nesteSkjermbilde= SKJERMBILDE_NEWSCOMPONENT;
                }
                break;
            }
            case SKJERMBILDE_NEWSLINES: {
                //Setter sammen newsLines elementet i NewsML dokumentet
                newsLines = new no.ingeberg.NewsML.NewsLines(headlineField.getText(), subheadlineField.getText(), bylineField.getText(),  
                                                            creditlineField.getText(), rightslineField.getText(), serieslineField.getText(), 
                                                            sluglineField.getText(), keywordlineField.getText());
                
                //Skifter skjermbildet
                nyArtPanel.remove(nyArtNewsLines);
                System.out.println(" fjerner nyArtNewsline");
                nyArtPanel.add(nyArtNewsComponent, java.awt.BorderLayout.CENTER);
                System.out.println("legger til NewsComp");
                //Setter status
                nesteSkjermbilde = SKJERMBILDE_NEWSCOMPONENT;
                aktivtSkjermbilde = SKJERMBILDE_NEWSCOMPONENT;
                break;
            }
        }
        pack();
    }
    
    private void nyArtPanelNesteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nyArtPanelNesteButtonActionPerformed
        skjermbildelogikk();
        //else if (komponenter[komponentteller].getName().compareTo("ledetekstPanel") == 0) {/** Ignore */} else if 
        //(komponenter[komponentteller].getName().compareTo("knappePanel") == 0) {   /** Ignore */} 
        //else System.out.println("Har funnet ukjent komponent: " + komponenter[komponentteller].getName());
        //Oppretter et NewsItem Objekt.
        //newsItem = new NewsItem(identification, newsManagement,(new NewsItemSub(newsComponent)));
        //newsEnvelope = new NewsEnvelope(getDateAndTime());
        // Oppretter et nytt NewsML Objekt, da vi skal ha all relevant info
        // newsML = new NewsML(newsEnvelope, newsItem);
        //}
        
    }//GEN-LAST:event_nyArtPanelNesteButtonActionPerformed
    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // Lokaliser ny NewsML fil.
        if (evt.getActionCommand().equals("Browse...")) {
            JFileChooser chooser = new javax.swing.JFileChooser("c:\\xml\\");
            ExampleFileFilter filter = new ExampleFileFilter();
            filter.addExtension("xml");
            filter.setDescription("eXstensive Markup Language file");
            chooser.setFileFilter(filter);
            chooser.setApproveButtonText("Velg");
            chooser.setDialogTitle("Lokaliser NewsML fil");
            chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
            int returnVal = chooser.showOpenDialog(new JFrame());
            //legger fila til i NewsML databasen eller gir feilmelding
            if (returnVal == JFileChooser.APPROVE_OPTION)
                // new AddDocument(chooser.getSelectedFile(), this, myConnection);
                new Put(chooser.getSelectedFile().toString());
            else feedbackLabel.setText("Du m velge en xml fil for  fortsette.");
        }
    }//GEN-LAST:event_jButton2ActionPerformed
    
    /****************************************************************************
     ******* InitNewArt1-7 setter alle GUI elementene slik de skal vre*********
     ****************************************************************************/
    
    private void initNewArt1() {
        /**************************************
         ************Identifikajson************
         ***************************************/
        myData = new LagNyArt();
        Object[] topicType = {"","literature", "disease", "health treatment",
                "prescription drugs", "dietary supplements",
                "health organisations", "medical research", "medical staff",
                "medicine", "preventative medicine", "hospital and clinic",
                "covernment health care", "medicare", "medical specialisation",
                "physical fitness", "forecast"};
                // Formaterer det som en model i MVC
                ComboBoxModel topicModel = new DefaultComboBoxModel(topicType);
                // Kobler modelen til VC
                topicTypeField.setModel(topicModel);
                
                
                //Setter og viser ProbiderID, verdien hentes fra det kont. vokabular
                //providerIDTextField.setText(myData.PROVIDERID);
                
                //Setter datoID feltet etter dagens dato, p rett format. Viser bruker.
                //SimpleDateFormat datoForm=new SimpleDateFormat("dd.MM.yyyy");
                //Date dato = new Date();
                //datoIdField.setText(datoForm.format(dato));
                
                //Generer en unik id til nyhetsposten og viser denne
                //Serial serial = new Serial(new File("c://java_prosjekt/no/ingeberg/" +
                //"newsMLGrensesnitt/identifikasjonsId.txt"));
                //nyhetspostId.setText(new Integer
                // (serial.getNextNyhetspostId()).toString());
                
                //lager en "nedtrekks gardin" der bruker kan velge revisjons nr.
                // Oppretter innholdet
                Object[] revisjonsID = {"", "0", "1", "2", "3", "4", "5"};
                // Formaterer det som en model i MVC
                ComboBoxModel aModel = new DefaultComboBoxModel(revisjonsID);
                // Kobler modelen til VC
                revisjonsIdField.setModel(aModel);
    }
    private void initNewArt2() {
        /**************************************
         ************NewsManagement************
         ***************************************/
        
        // newsItemType	- Angir hvilke type en nyhetspost er av.
        //Verdiene er hentet fra et kontrollert vokabular.
        Object[] newsItemType = { "", "Nyheter", "Data", "Reklame", "TopicSet",
                "DTD", "Dokument", "Katalog", "Advarsel"};
                // Oppretter innholdet
                // Formaterer det som en model i MVC
                ComboBoxModel aModel = new DefaultComboBoxModel(newsItemType);
                // Kobler modelen til VC
                newsItemTypeField.setModel(aModel);
                
                
                //status - Angir nyhetspostens anvenlighet.
                //Verdiene i dette elementet er hentet fra et kontrollert vokabular.
                // Oppretter innholdet
                Object[] status = {"", "usable", "Embargoed", "Withheld", "canceled"};
                statusField.setModel(new DefaultComboBoxModel(status));
                // Formaterer innholdet som en modell i MVC, og kobler modelen til VC
                
                //ny status
                // Oppretter innholdet
                Object[] nyStatus = {"", "usable", "Embargoed", "Withheld", "canceled"};
                nyStatusField.setModel(new DefaultComboBoxModel(nyStatus));
                // Formaterer innholdet som en modell i MVC, og kobler modelen til VC
                
                //urgency- Angir hvor viktig nyhetsposten anses for  vre.
                //Verdiene hentes fra et kontrollert vokabular.
                Object[] urgency = {"", "1", "2", "3", "4", "5"};// Oppretter innholdet
                urgencyField.setModel(new DefaultComboBoxModel(urgency));
                // Formaterer innholdet som en modell i MVC, og kobler modelen til VC
    }
    
    private void initNewArt3() {
        /**************************************
         ************NewsComponent*************
         **************************************/
        
    }
    
    private void initNewArt4() {
        /**************************************
         ************Catalog*******************
         **************************************
         * Elementet identifiserer eller lokaliserer standard
         * vokabular og indikerer hvor i NewsML dokumentet visse Topics er brukt.*/
        
        
    }
    
    private void initNewArt5() {
        /**************************************
         ************TopicSet*******************
         **************************************
         * Elementet beskriver emnet til deler eller hele nyhetsposter.*/
    }
    
    private void initNewArt6() {
        /**************************************
         ************ContentItem.**************
         **************************************/
        //mediaTypeFN - beskriver media typen. Bruker skriver inn.
        //Verdiene er hentet fra et kontrollert vokabular.
        Object[] mediaTypeFN = {"", "Tekst", "Grafikk", "Foto", "Lyd", "Video", "Animasjon"};
        // Oppretter innholdet
        // Formaterer det som en model i MVC
        ComboBoxModel aModel = new DefaultComboBoxModel(mediaTypeFN);
        // Kobler modelen til VC
        mediaTypeFNComboBox.setModel(aModel);
        
        int mediaTypeFNRes = mediaTypeFNComboBox.getSelectedIndex();
        //formatFN -  -angir formatet. Bruker skriver inn
        if (mediaTypeFNRes == 1){
            Object[] formatFN = {"","txt", "pfd"};
            // Oppretter innholdet
            // Formaterer det som en model i MVC
            ComboBoxModel formatModel = new DefaultComboBoxModel(formatFN);
            // Kobler modelen til VC
            formatFNComboBox.setModel(formatModel);
        }
        //mimeTypeFN - Angir mimetypen. Bruker skriver inn.
    }
    
    private void initNewArt7() {
        /***************************************
         ************NewsLines******************
         **Her skriver bruker inn alle feltene**
         **************************************/
    }
    
    private void initNewArt8() {
        /***************************************
         ************NewsItem******************
         **Her skriver bruker inn alle feltene**
         **************************************/
    }
    
    private void initSeachArt(){
        Object[] urgency = {"", "Forfatter", "2", "3", "4", "5"};// Oppretter innholdet
        seachelementField.setModel(new DefaultComboBoxModel(urgency));
    }
    
    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        System.exit(0);
    }//GEN-LAST:event_exitMenuItemActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new AdminBaseGUI().setVisible(true);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JTextField bylineField;
    private javax.swing.JTextField commentField;
    private javax.swing.JTextField contentCommentField;
    private javax.swing.JMenuItem contentsMenuItem;
    private javax.swing.JMenuItem copyMenuItem;
    private javax.swing.JTextField creatorField;
    private javax.swing.JTextField creditlineField;
    private javax.swing.JMenuItem cutMenuItem;
    private javax.swing.JMenuItem deleteMenuItem;
    private javax.swing.JMenu editMenu;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JLabel feedbackLabel;
    private javax.swing.JPanel feedbackPanel;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JTextField fileNameField;
    private javax.swing.JTextField firstCreatedField;
    private javax.swing.JComboBox formatFNComboBox;
    private javax.swing.JTextField headlineField;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton13;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JButton jButton9;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel40;
    private javax.swing.JLabel jLabel42;
    private javax.swing.JLabel jLabel43;
    private javax.swing.JLabel jLabel44;
    private javax.swing.JLabel jLabel45;
    private javax.swing.JLabel jLabel46;
    private javax.swing.JLabel jLabel48;
    private javax.swing.JLabel jLabel49;
    private javax.swing.JLabel jLabel50;
    private javax.swing.JLabel jLabel51;
    private javax.swing.JLabel jLabel52;
    private javax.swing.JLabel jLabel53;
    private javax.swing.JLabel jLabel54;
    private javax.swing.JLabel jLabel55;
    private javax.swing.JLabel jLabel56;
    private javax.swing.JLabel jLabel60;
    private javax.swing.JLabel jLabel61;
    private javax.swing.JLabel jLabel63;
    private javax.swing.JLabel jLabel64;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextField jTextField16;
    private javax.swing.JTextField keywordlineField;
    private javax.swing.JPanel knappePanel;
    private javax.swing.JPanel ledetekstPanel;
    private javax.swing.JPanel leggInnFilPanel;
    private javax.swing.JComboBox mediaTypeFNComboBox;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JComboBox mimeTypeFNComboBox;
    private javax.swing.JTextField nameLabelField;
    private javax.swing.JComboBox newsItemTypeField;
    private javax.swing.JPanel nyArtContentItem;
    private javax.swing.JPanel nyArtNewsComponent;
    private javax.swing.JPanel nyArtNewsLines;
    private javax.swing.JPanel nyArtNewsManagement;
    private javax.swing.JPanel nyArtPanel;
    private javax.swing.JButton nyArtPanelAvsluttButton;
    private javax.swing.JButton nyArtPanelNesteButton;
    private javax.swing.JPanel nyArtSenterPanel1;
    private javax.swing.JComboBox nyStatusField;
    private javax.swing.JTextField nyStatusTidField;
    private javax.swing.JMenuItem openMenuItem;
    private javax.swing.JMenuItem pasteMenuItem;
    private javax.swing.JComboBox revisjonsIdField;
    private javax.swing.JTextField rightslineField;
    private javax.swing.JMenuItem saveAsMenuItem;
    private javax.swing.JMenuItem saveMenuItem;
    private javax.swing.JComboBox seachelementField;
    private javax.swing.JTextField serieslineField;
    private javax.swing.JTextField sizeInBytesField;
    private javax.swing.JTextField sluglineField;
    private javax.swing.JPanel sokPanel;
    private javax.swing.JTextField sourceField;
    private javax.swing.JComboBox statusField;
    private javax.swing.JTextField subheadlineField;
    private javax.swing.JTextField thisRevisionCreatedField;
    private javax.swing.JTextField topicComField;
    private javax.swing.JTextField topicDesField;
    private javax.swing.JComboBox topicTypeField;
    private javax.swing.JComboBox urgencyField;
    private javax.swing.JPanel valgteFiler;
    // End of variables declaration//GEN-END:variables
    
}
