package no.ingeberg.newsMLGrensesnitt;

import org.xmldb.api.*;
import org.xmldb.api.base.*;
import org.xmldb.api.modules.*;
import java.io.*;


/**
 * Add a document to the exist database.
 *
 * Call with
 *
 * java -jar start.jar org.exist.examples.xmldb.Put collection docName
 *
 */
public class Put {
    
    //public final String URI = "xmldb:exist://www.garshol.org:8080/exist/xmlrpc";
    public final String URI = "xmldb:exist://localhost:8080/exist/xmlrpc";
    
    protected void usage() {
        System.out.println("usage: org.exist.examples.xmldb.Put collection docName");
        System.exit(0);
    }
    
    public Put(String file) {
        try{
            Collection db = connectDB("/db");
            String data = readFileFromDisk(file);
            
            XMLResource document = (XMLResource) db.createResource(null,"XMLResource");
            document.setContent(data);
            db.storeResource(document);
            
            db.close();
        }
        catch(org.xmldb.api.base.XMLDBException e){System.out.println("Problemer med  lagge til fila i databasen: "+ e.toString());}
        catch(java.lang.ClassNotFoundException e){System.out.println("Finner ikke driver til databasen: "+ e.toString());}
        catch(java.lang.InstantiationException e){System.out.println("Kan ikke lage ny instans av database: "+ e.toString());}
        catch(java.lang.IllegalAccessException e){System.out.println("Har ikke tilgangsrettigheter til databasen: "+ e.toString());}
        
    }
    
    private Collection connectDB(String collection)
    throws java.lang.ClassNotFoundException,
    java.lang.InstantiationException,
    java.lang.IllegalAccessException,
    org.xmldb.api.base.XMLDBException{
        // initialize driver
        Class cl = Class.forName("org.exist.xmldb.DatabaseImpl");
        Database database = (Database)cl.newInstance();
        database.setProperty("create-database", "true");
        DatabaseManager.registerDatabase(database);
        
        // try to get collection
        Collection col = DatabaseManager.getCollection(URI + collection);
        if(col == null) {
            // collection does not exist: get root collection and create.
            // for simplicity, we assume that the new collection is a
            // direct child of the root collection, e.g. /db/test.
            // the example will fail otherwise.
            Collection root = DatabaseManager.getCollection(URI + "/db");
            CollectionManagementService mgtService = (CollectionManagementService)root.getService("CollectionManagementService", "1.0");
            col = mgtService.createCollection(collection.substring("/db/".length()));
        }
        return col;
    }
    
    public String readFileFromDisk(String fileName) {
        byte[] fileBuffer = null;
        try{
            File file = new File(fileName);
            FileInputStream insr = new FileInputStream(file);
            fileBuffer = new byte[(int)file.length()];
            insr.read(fileBuffer);
            insr.close();
        }
        catch(Exception e){System.out.println("Problemer med  lese fila fra disk: "+e.toString()); }
        if (fileBuffer !=null)return new String(fileBuffer);
        else return new String();
    }
}
