package no.ingeberg.newsMLGrensesnitt;
import javax.xml.transform.OutputKeys;
import org.exist.storage.serializers.EXistOutputKeys;
import org.xmldb.api.DatabaseManager;
import org.xmldb.api.base.Collection;
import org.xmldb.api.base.Database;
import org.xmldb.api.modules.XMLResource;
import java.io.*;
import java.util.*;

/**
 *  Retrieve a document from the database. To run this example enter:
 *  java -jar start.jar org.exist.examples.xmldb.Retrieve collection document
 *  in the root directory of the distribution.
 *	@author     Wolfgang Meier <meier@ifs.tu-darmstadt.de>
 */
public class RetrieveExist {
    protected static String driver = "org.exist.xmldb.DatabaseImpl";
    protected static String URI = "xmldb:exist://www.garshol.org:8080/exist/xmlrpc";
    protected static String xsl = "<?xml-stylesheet type='text/xsl' href='C:\\Documents and Settings\\Marit\\Mine dokumenter\\!Oppgave\\" +
                                    "test6_okt_04\\test3.xsl'?>\n";
    protected static File fil = new File("C:\\JTest.xml");
       
    public RetrieveExist(String docName) throws Exception {
    //static void main(String[] args) throws Exception {
        System.out.println("usage: org.exist.examples.xmldb.Retrieve collection docName");
        String collection = "/db";
        //String docName = "newsML.XML";
        
        // initialize database drivers
        Class cl = Class.forName(driver);
        Database database = (Database) cl.newInstance();
        DatabaseManager.registerDatabase(database);
        
        // get the collection
        Collection col = DatabaseManager.getCollection(URI + collection);
        col.setProperty(OutputKeys.INDENT, "yes");
        col.setProperty(EXistOutputKeys.EXPAND_XINCLUDES, "no");
        col.setProperty(EXistOutputKeys.PROCESS_XSL_PI, "yes");
        XMLResource res = (XMLResource)col.getResource(docName);
        if(res == null) System.out.println("document not found!");
        else {
            StringBuffer sb = new StringBuffer(res.getContent().toString());
            int i = sb.indexOf("<?xml-stylesheet");
            if (i != -1) sb.replace(i, sb.indexOf("<NewsML"), xsl+"<NewsML");    // har funnet et gammal xsl, bytter det ut
            else sb.insert(sb.indexOf("<NewsML"),xsl);
            BufferedWriter bw = new BufferedWriter(new FileWriter(fil));
            bw.write(sb.toString());
            bw.flush();
            bw.close();
            HTMLBrowser browser = new HTMLBrowser("C:\\JTest.xml");
            //System.out.println(sb.toString());
        }
    }
}
