/*
 * Serial.java
 */

package no.ingeberg.newsMLGrensesnitt.tools;
import java.io.*;

/**
 *
 * @author  Marit Ingeberg
 */
public class Serial {
    private File file = null; // bytt denne med ein tabell i DerbyDB
    private int[] verdier = new int[3];
    
    public Serial(File initfile) { file = initfile; }
    
    public int getNextNyhetspostId() {
        load();                     // Les ut gammal verdi
        verdier[0] = ++verdier[0];  // Oppdaterer verdien
        save();                     // Lagr endringa til fil
        return verdier[0];          // Send tilbake neste int
    }
    
    public int getNextXXXId() {
        load();                     // Les ut gammal verdi
        verdier[1] = ++verdier[1];  // Oppdaterer verdien
        save();                     // Lagr endringa til fil
        return verdier[1];          // Send tilbake neste int
    }
    
    public int getNextYYYId() {
        load();                     // Les ut gammal verdi
        verdier[2] = ++verdier[2];  // Oppdaterer verdien
        save();                     // Lagr endringa til fil
        return verdier[2];          // Send tilbake neste int
    }
    
    private void load() {
        try{
            BufferedReader br = new BufferedReader(new FileReader(file));
            verdier[0] = new Integer(br.readLine()).intValue();
            verdier[1] = new Integer(br.readLine()).intValue();
            verdier[2] = new Integer(br.readLine()).intValue();
            br.close();
        }
        catch (IOException ioe){ ioe.printStackTrace(); }
        catch (Exception e){ e.printStackTrace(); }
    }
    
    private void save() {
        try{
            BufferedWriter bw = new BufferedWriter(new FileWriter(file));
            bw.write(new String(new Integer(verdier[0]).toString()+"\n"));
            bw.write(new String(new Integer(verdier[1]).toString()+"\n"));
            bw.write(new String(new Integer(verdier[2]).toString()+"\n"));
            bw.flush();
            bw.close();
        }
        catch (IOException ioe){ ioe.printStackTrace(); }
        catch (Exception e){ e.printStackTrace(); }
    }
}
