/*
 * test.java
 *
 */

package no.ingeberg.newsmldb;
import java.io.*;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.PreparedStatement;
import java.sql.DriverManager;

/**
 *
 * @author Marit
 */
public class MySQLsaveFile {
    /**
     *  CREATE TABLE binary_data (
     *  id INT(4) NOT NULL AUTO_INCREMENT PRIMARY KEY,
     *  description VARCHAR(50),
     *  bin_data LONGBLOB,
     *  filename VARCHAR(50),
     *  filesize VARCHAR(50),
     *  filetype VARCHAR(50)
     *  );
     *  
     *  Vist "Server configuration denies access to data source" s:
     *  M kjyre denne via eit terminal vindu for  f tilgang til databasen fra anna enn localhoast:
     *  GRANT ALL ON *.* TO root@10.0.0.2 IDENTIFIED BY "qwerty";
     *  
     *   querry="\"INSERT INTO binary_data (description,bin_data,filename,filesize,filetype)";
     *   querry+="\"VALUES ('description','$data','$form_data_name','$form_data_size','$form_data_type')");
     */
    
    private static String CONNECT = "jdbc:mysql://10.0.0.8:3306/newsml";
    private static String USER = "root";
    private static String PWD = "qwerty";
    private Connection conn = null;
    private ResultSet rs = null;
    private Statement stmt = null;
    private boolean connected = false;
    
    /*
    public static void main(String[] args) throws Exception {
        MySQLsaveFile b = new MySQLsaveFile();
    }
     */
    
    public MySQLsaveFile() {
        try {
            Class.forName("org.gjt.mm.mysql.Driver").newInstance();
            conn = DriverManager.getConnection(CONNECT, USER, PWD);
            stmt = conn.createStatement();
            connected = true;
        } catch (SQLException sqle) { sqle.printStackTrace(); } catch (Exception e) { e.printStackTrace(); }
    }
    
    /**
     * Metoden tar inn en fil fra og legger den inn i MySQL databasen.
     * Returnerer primrnkkelen til opprettet tuppel, eller 0 ved feil. 
     */
    public int addFile(File file) {
        FileInputStream fis = null;
        byte[] blob = null;
        try {
            fis = new FileInputStream(file);
            blob = new byte[fis.available()];
            int data;
            int i = 0;
            while ((data = fis.read()) != -1) {
                blob[i++] = (byte)data;
            }
        } catch (java.io.FileNotFoundException ex){
            System.out.println("Finner ikke fila som skal legges inn i MySQL basen:" + ex.toString());
            ex.printStackTrace();
        } catch (java.io.IOException ioe){
            System.out.println("En feil har oppsttt i innlegg av fil i MySQL basen:" + ioe.toString());
            ioe.printStackTrace();
        }
        
        try {
            PreparedStatement pstmt = conn.prepareStatement("INSERT INTO binary_data (description,bin_data,filename,filesize,filetype) " +
                                                            "VALUES(?,?,?,?,?)");
            pstmt.setString(1, "");  // beskrivelse
            pstmt.setBytes(2, blob); // innhold i fil
            pstmt.setString(3, file.getName()); // filnavn
            pstmt.setString(4, new Integer(blob.length).toString()); // filesize in bytes
            String ext = "";
            if (file.isFile() && file.getName().length() > 0 && file.getName().contains(".")) {
                ext = file.getName().substring(file.getName().lastIndexOf("."), file.getName().length());
            }
            pstmt.setString(5, ext); // filtype beskrivelse, eller blank
            pstmt.execute();
            ResultSet key = pstmt.getGeneratedKeys();
            if (key.next()) {
                // Er ferdig i denne metoden, retrner nkkel
                int t = key.getInt(1);
                System.out.println(t);
                return t;
            }
            else {
                // Denne burde ikke ha forekommet.....
                System.out.println("Har ikke ftt lagt til fil i databasen.");
            }
        } 
        catch (SQLException E) {
            E.printStackTrace();
        }
        return 0;
    }
    
    public void close(){
        if (rs != null) {
            try { rs.close(); } catch (SQLException SQLE) {}
        }
        if (stmt != null) {
            try { stmt.close(); } catch (SQLException SQLE) {}
        }
        if (conn != null) {
            try { conn.close(); } catch (SQLException SQLE) {}
        }
    }
}
